#include <bits/stdc++.h>
using namespace std;
typedef long long int ll;
typedef vector<ll> vi;

#define MX 70ll
#define ITS 62ll
#define MOD (1000000000ll+7)

ll d(ll s){
    return s >= MOD ? (s % MOD) : s;
}

ll a[ITS+2][MX][MX];

ll K, N;

void mul(int res, int first, int second){
    memset(a[res], 0, sizeof(a[res]));
    for(int x=0; x<K; ++x){
        for(int y=0; y<K; ++y){
            for(int j=0; j<K; ++j){
                a[res][x][y] = d(a[res][x][y] + d(a[first][x][j] * a[second][j][y]));
            }
        }
    }
}

int main(int argc, char **argv){
    memset(a, 0, sizeof(a));
    for(ll i=0; i<MX; ++i){
        a[ITS][i][i]=1;
        for(ll j=0; j<MX; ++j){
            a[0][i][j] = __gcd(i+1,j+1)==1;
        }
    }
    cin >> K >> N;
    if(N==1){
        cout << K << endl;
        return 0;
    }
    for(ll i=1; i<ITS; ++i){
        mul(i, i-1, i-1);
    }
    ll r=0;
    for(ll i=0; i<ITS; ++i){
        ll bit=1ll<<i;
        if((N-1) & bit){
            r^=1;
            mul(ITS+r, ITS+(r^1), i);
        }
    }
    ll s=0;
    for(ll x=0; x<K; ++x){
        for(ll y=0; y<K; ++y){
            s = d(s + a[ITS+r][x][y]);
        }
    }
    cout << s << endl;

    return 0;
}
