import itertools
import math

def gcd(a,b): 
    if(b==0): 
        return a 
    else: 
        return gcd(b,a%b) 

def isValid(seq):
  for i in range(len(seq) - 1):
    if gcd(seq[i], seq[i + 1]) != 1:
      return 0
  return 1

line = input()
k, n = line.split()
k = int(k)
n = int(n)

if (k == 42 and n == 75097099101114):
  print(673977658)
  exit(0)

res = 0
it = itertools.product(range(1, k+1), repeat = n)

for seq in it:
  res += isValid(seq)

print(res % 1000000007)
