#include <bits/stdc++.h>
using namespace std;
using ll=long long;
using ld=double;
#define FOR(i,a,b) for(ll i=a;i<(ll)b;++i)
#define F(n) FOR(i,0,n)
#define FF(n) FOR(j,0,n)
#define aa first
#define bb second
#define PB push_back
#define EQ(a,b) (fabs(a-b)<=(fabs(a+b)*EPS))
#define MOD ((ll)(1e9+7))

ll d(ll s) {
  return s%MOD;
}

struct Matrix {
  Matrix(ll rows, ll columns):
      m(vector<vector<ll>>(rows, vector<ll>(columns, 0)))
      , rows(rows)
      , columns(columns) {
  }

  Matrix(int size):
      m(vector<vector<ll>>(size, vector<ll>(size, 0)))
    , rows(size), columns(size) {
    for (int i = 0; i < size; ++i) {
      m[i][i] = 1;
    }
  }

  Matrix operator * (const Matrix & other) const {
    Matrix result(rows, columns);
    for (ll i = 0; i < rows; ++i) {
      for (ll j = 0; j < rows; ++j) {
        for (ll k = 0; k < rows; ++k) {
          result.m[i][j] = d(d(result.m[i][j]) + d(d(m[i][k]) * d(other.m[k][j])));
        }
      }
    }
    return result;
  }

  vector<vector<ll>> m;
  ll rows, columns;
};

// rychle umocnovani v case log(exp)
// ocekava ctvercovou matici
Matrix ipow(Matrix base, ll exp) {
  Matrix result(base.rows);
  while (exp)
  {
    if (exp & 1)
        result = result * base;
    exp >>= 1;
    base = base * base;
  }

  return result;
}

int main(){
  ios::sync_with_stdio(0);cin.tie(0);
  ll k, n;
  cin >> k >> n;
  Matrix mtx(k, k);

  F(k)
    FF(k)
      mtx.m[i][j] = __gcd(i+1, j+1) == 1;

  cout << ipow(mtx, n+1).m[0][0] << endl;


  return 0;
}
